
# If you meet any unexpected problems when running the code, or want to report bugs, please STOP here. Go to the following link instead and fill out the information there:
https://github.com/tensorpack/tensorpack/issues/new?template=unexpected-problems---bugs.md


Otherwise, you can post here for:
1. Feature Requests:
  + Note that you can implement a lot of features by extending Tensorpack
   (See http://tensorpack.readthedocs.io/tutorial/index.html#extend-tensorpack).
   It does not have to be added to Tensorpack unless you have a good reason.

2. Questions on Using/Understanding Tensorpack:
  + Your question is probably answered in [tutorials](http://tensorpack.readthedocs.io/tutorial/index.html#user-tutorials). Read it first.
  + We answer "HOW to do X with Tensorpack" for a well-defined X.
    We also answer "HOW/WHY Tensorpack does X" for some X that Tensorpack or its examples are doing.

Some typical questions that we DO NOT answer:

+ "Could you implement a paper / other variants of a paper / additional features of a paper ?"
  -- The answer is: we have no plans to do so.
	We take feature requests on the library, but not on examples.
  We don't implement papers or variants/features of a paper for you,
  unless it can demonstrate some Tensorpack features not yet demonstrated in the existing examples.
  If you don't know how to do something yourself, you may ask a usage question.

+ "The examples do not perform as expected after I change the models/dataset/parameters/etc."

  Tensorpack maintainers make sure the examples perform well without modifications.
  But it's your job to pick the model and parameters that are suitable for your own situation.
  We cannot help with such questions unless they appear to be a bug in tensorpack.

+ "Why my own model doesn't perform well?", "I don't understand this paper you implement.",
  "How should I change the parameters for my own dataset?"

  We do not answer machine learning questions.


You can also use gitter (https://gitter.im/tensorpack/users) for more casual discussions.
